@echo off

:: ###################################################################################
:: # Shell script for starting Madsonic Node.  See more on http://madsonic.org
:: ###################################################################################

:settings
 setlocal ENABLEEXTENSIONS ENABLEDELAYEDEXPANSION

 rem JAVA JRE/JDK path
 set JRE_HOME=
 set JDK_HOME=

 rem The directory where Madsonic will create files. Make sure it is writable.
 set MADSONIC_HOME=c:\madsonic-node

 rem The host name or IP address on which to bind Madsonic. Only relevant if you have
 rem multiple network interfaces and want to make Madsonic available on only one of them.
 rem The default value 0.0.0.0 will bind Madsonic to all available network interfaces.
 set MADSONIC_HOST=0.0.0.0

 rem The port on which Madsonic will listen for incoming HTTP traffic.
 set MADSONIC_PORT=8181

 rem The port on which Madsonic will listen for incoming HTTPS traffic (0 to disable).
 set MADSONIC_HTTPS_PORT=0

 rem The context path (i.e., the last part of the Madsonic URL).  Typically "/" or "/madsonic".
 set MADSONIC_CONTEXT_PATH=/

 rem The directory for transcode binary (default: %MADSONIC_HOME%\transcode)
 set MADSONIC_DEFAULT_TRANSCODE_FOLDER=
 
 rem The memory initial size (Init Java heap size) in megabytes.
 set INIT_MEMORY=128

 rem The memory limit (max Java heap size) in megabytes.
 set MAX_MEMORY=256

 
:getjrelocation
 rem Resolve location of Java runtime environment
 set KeyName=HKEY_LOCAL_MACHINE\SOFTWARE\JavaSoft\Java Runtime Environment
 set Cmd=reg query "%KeyName%" /s
 for /f "tokens=2*" %%i in ('%Cmd% ^| find "JavaHome"') do set JRE_HOME=%%j

:getjdklocation
 rem Resolve location of Java JDK environment
 set KeyName=HKEY_LOCAL_MACHINE\SOFTWARE\JavaSoft\Java Development Kit
 set Cmd=reg query "%KeyName%" /s
 for /f "tokens=2*" %%i in ('%Cmd% ^| find "JavaHome"') do set JDK_HOME=%%j

:setenv
 rem Check
 if "%JRE_HOME%%JDK_HOME%"=="" goto errornojava
 
 if not "%JRE_HOME%"=="" set JAVA_HOME=%JRE_HOME%
 if not "%JDK_HOME%"=="" set JAVA_HOME=%JDK_HOME%
 
 if not "%JAVA_HOME%"=="" (
        "%JAVA_HOME%\bin\java.exe" ^
        -Xms%INIT_MEMORY%m ^
        -Xmx%MAX_MEMORY%m ^
        -Dmadsonic.home=%MADSONIC_HOME% ^
        -Dmadsonic.host=%MADSONIC_HOST% ^
        -Dmadsonic.port=%MADSONIC_PORT% ^
        -Dmadsonic.httpsPort=%MADSONIC_HTTPS_PORT% ^
        -Dmadsonic.contextPath=%MADSONIC_CONTEXT_PATH% ^
        -jar madsonic-node.jar
 )
 rem    -Djavax.sound.sampled.SourceDataLine="#ALSA" ^        
 
 goto end

:errornojava
 echo Failed to locate any installed java environments event tried locating a JDK, please install a Java Runtime Evnironment or JDK
 goto end
 
:end
 endlocal